Unit Calculator;

interface

uses
  SysUtils;

const
 OperSet:set of char=
  ['+','-','*','/','(',')','[',']'];
 NumSet:set of char=
  ['0','1','2','3','4','5','6','7','8','9','.'];
 VarSet:set of char=
  ['t'];
 FuncSet:set of char=
  ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
   'x','y','u','w','v','z'];
 maxstack=300;
 maxstack1=550;
 maxrec=300;
 a1=0;
 a2=-60;

type
 TMathRec=record
  Number:Single;
  Code:ShortInt;
 end;
 TMathRecord=record
  I:array[1..maxrec] of TMathRec;
  Length:word
 end;
 TStackArr=
  array[1..maxstack] of Single;
 TStack1Arr=
  array[1..maxstack1] of ShortInt;
 TStack=record
  Top:word;
  IStack:TStackArr
 end;
 TStack1=record
  Top:word;
  IStack:TStack1Arr
 end;

var
 IntTime:Single;
 Oper:Array[-127..127] of String;

procedure ToRpn(const s:string;var MathRec:TMathRecord;var ErrorCode:integer);
function WriteRpn(const MathRec:TMathRecord):String;
procedure EvaluateRpn(const MathRec:TMathRecord;var ErrorCode:Integer;var Result:Single);
procedure InitMathRec(var MathRec:TMathRecord);
function GetAmplitude(const t:Single):Single;
function Rect(const t:Single):Single;
function Triangle(const t:Single):Single;
procedure SetTime(const t:Single);

implementation

uses
 Generator;
var
 Stack:TStack;
 Stack1:TStack1;

function GetAmplitude;
var
 k:cardinal;
begin
 if ((t<0) or (t>WAV.aTime)) then
  GetAmplitude:=0
 else
 begin
  k:=Round(t/WAV.DeltaTime);
  GetAmplitude:=WAV.AudioDataR[k]/30000;
 end;
end;

function Rect;
var
 k:Integer;
begin
 k:=Round(t);
 if Odd(k) then
  Rect:=1
 else
  Rect:=0;
end;

function Triangle;
var
 k:Integer;
begin
 k:=Round(t);
 Triangle:=t - k;
end;

procedure InitMathRec(var MathRec:TMathRecord);
var
 i:word;
begin
 for i:=1 to maxrec do
 begin
  MathRec.I[i].Number:=0;
  MathRec.I[i].Code:=0
 end;
 MathRec.Length:=0;
end;

procedure InitStack;
begin
 Stack.Top:=1
end;

procedure Push(const x:Single);
begin
 Stack.IStack[Stack.Top]:=x;
 inc(Stack.Top)
end;

function Pop(var x:Single):boolean;
begin
 if Stack.Top<1 then
  pop:=false
                else
 begin
  dec(Stack.Top);
  x:=Stack.IStack[Stack.Top];
  pop:=true
 end;
end;

procedure InitStack1;
var
 i:word;
begin
 for i:=1 to maxstack1 do
  Stack1.IStack[i]:=0;
 Stack1.Top:=1
end;

procedure Push1(const x:ShortInt);
begin
 if Stack1.Top>maxstack1 then
  writeln('Stack1 over...')
                       else
 begin
  Stack1.IStack[Stack1.Top]:=x;
  inc(Stack1.Top)
 end
end;

function Pop1(var x:ShortInt):boolean;
begin
 if Stack1.Top<1 then
  pop1:=false
                else
 begin
  dec(Stack1.Top);
  x:=Stack1.IStack[Stack1.Top];
  pop1:=true
 end;
end;

function GetCode(const s:string):ShortInt;
begin
 GetCode:=0;
 if s='sin' then
  GetCode:=-1;
 if s='cos' then
  GetCode:=-2;
 if s='zg' then
  GetCode:=-3;
 if s='czg' then
  GetCode:=-4;
 if s='exp' then
  GetCode:=-5;
 if s='ln' then
  GetCode:=-6;
 if s='rand' then
  GetCode:=-7;
 if s='amp' then
  GetCode:=-8;
 if s='rcn' then
  GetCode:=-9;
 if s='ran' then
  GetCode:=-10;
 if s='sqr' then
  GetCode:=-11; 
 if s='ifm' then
  GetCode:=-41;
 if s='ifl' then
  GetCode:=-42;
 if s='t' then
  GetCode:=127;
end;


function Eval(const x:Single; const Code:ShortInt):Single;
begin
 Eval:=0;
 if Code=-1 then
  Eval:=sin(x);
 if Code=-2 then
  Eval:=cos(x);
 if Code=-3 then
  Eval:=sin(x)/cos(x);
 if Code=-4 then
  Eval:=cos(x)/sin(x);
 if Code=-5 then
  Eval:=exp(x);
 if Code=-6 then
  Eval:=ln(x);
 if Code=-7 then
 begin
  Eval:=x*(Random(65535) - 32767)/32767;
 end;
 if Code=-8 then
  Eval:=GetAmplitude(x);
 if Code=-9 then
  Eval:=Rect(x);
 if Code=-10 then
  Eval:=Triangle(x);
 if Code=-11 then
  if x>0 then
   Eval:=sqrt(x)
  else
   Eval:=0;
end;

function Eval1(const x1,x2:Single; const Code:ShortInt):Single;
begin
 Eval1:=0;
 if Code=-41 then
 begin
  if x1>x2 then
   Eval1:=1
  else
   Eval1:=0
 end;
 if Code=-42 then
 begin
  if x1<x2 then
   Eval1:=1
  else
   Eval1:=0
 end;
end;

procedure ToRpn;
var
 i,j,k,l:word;
 code,ss:ShortInt;
 num:Single;
 err:boolean;
 ValErr:integer;
 s1,funcs:string;

begin
 InitStack1;
 InitMathRec(MathRec);
 ErrorCode:=0;
 l:=length(s);
 i:=1;k:=1;
 while i<=l do
 begin

  if s[i]=' ' then inc(i);

  if (s[i] in NumSet) then
  begin
   j:=1;
   while (s[i+j] in NumSet) do
    inc(j);
   s1:=copy(s,i,j);
   val(s1,num,ValErr);
   if ValErr<>0 then
   begin
    ErrorCode:=5;
    InitMathRec(MathRec);
    Exit
   end;
   MathRec.I[k].Number:=num;
   MathRec.I[k].Code:=0;
   inc(k);
   while ((Stack1.IStack[Stack1.Top-1]<0) and (Stack1.Top>1)) do
   begin
    err:=pop1(ss);
    MathRec.I[k].Number:=0;
    MathRec.I[k].Code:=ss;
    inc(k);
   end;
   i:=i+j;
  end;

  if (s[i] in FuncSet) then
  begin
   j:=0;
   while ((S[i+j] in FuncSet) or (S[i+j] in NumSet)) do
    inc(j);
   funcs:=copy(S,i,j);
   Code:=GetCode(funcs);
   push1(code);
   i:=i+j;
  end;

  if (s[i] in VarSet) then
  begin
   MathRec.I[k].Number:=0;
   MathRec.I[k].Code:=GetCode(s[i]);
   inc(k);
   inc(i);
  end;

  if (s[i] in OperSet) then
  begin
   ss:=0;
   case s[i] of
    '(':push1(5);
    ')':repeat
         err:=pop1(ss);
         if not err then
         begin
          ErrorCode:=1;
          InitMathRec(MathRec);
          exit;
         end;
         if ss<>5 then
         begin
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end
        until ss=5;
    '+':begin
         while ((Stack1.Top>1) and (Stack1.IStack[Stack1.Top-1]<5)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(3);
        end;
    '-':begin
         while ((Stack1.Top>1) and (Stack1.IStack[Stack1.Top-1]<5)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(4);
        end;
    '*':begin
         while ((Stack1.IStack[Stack1.Top-1] < 3) and (Stack1.Top>1)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(1);
        end;
    '/':begin
         while ((Stack1.IStack[Stack1.Top-1] < 3) and (Stack1.Top>1)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(2);
        end;
   end;
   inc(i);
  end;
 end;
 while Stack1.Top>1 do
 begin
  err:=pop1(ss);
  MathRec.I[k].Code:=ss;
  MathRec.I[k].Number:=0;
  inc(k)
 end;
 MathRec.Length:=k-1
end;

function WriteRpn;
var
 i:word;
 S,S1:String;
begin
 S:='';
 for i:=1 to MathRec.Length do
 begin
  if MathRec.I[i].Code=0 then
  begin
   Str(MathRec.I[i].Number:6:3,S1);
   S:=S + S1 + ' ';
  end;
  if MathRec.I[i].Code<>0 then
   S:=S + Oper[MathRec.I[i].Code] + ' ';
 end;
 WriteRpn:=S
end;

procedure EvaluateRpn;
var
 res1,res2:boolean;
 v1,v2,res:Single;
 i:word;
begin
 InitStack;
 for i:=1 to MathRec.Length do
 begin
  if MathRec.I[i].Code=0 then
   Push(MathRec.I[i].Number);

  if (MathRec.I[i].Code>100) then
  begin
   if (MathRec.I[i].Code=127) then
    push(IntTime);
  end;

  if ((MathRec.I[i].Code<0) and (MathRec.I[i].Code>-20)) then
  begin
   res1:=pop(v1);
   if not res1 then
   begin
    ErrorCode:=1;
    Result:=0;
    exit
   end;
   res:=Eval(v1,MathRec.I[i].Code);
   push(res);
  end;

  if ((MathRec.I[i].Code<-20) and (MathRec.I[i].Code>-60)) then
  begin
   res1:=pop(v1);
   res2:=pop(v2);
   if not (res1 and res2) then
   begin
    ErrorCode:=1;
    Result:=0;
    exit
   end;
   res:=Eval1(v2,v1,MathRec.I[i].Code);
   push(res);
  end;

  if ((MathRec.I[i].Code>0) and (MathRec.I[i].Code<100)) then
  begin
   res1:=pop(v1);
   res2:=pop(v2);
   if not (res1 and res2) then
   begin
    ErrorCode:=1;
    Result:=0;
    exit
   end;
   case MathRec.I[i].Code of
    1:res:=v1*v2;
    4:res:=v2-v1;
    3:res:=v1+v2;
    2:begin
       if v1=0 then
       begin
        ErrorCode:=3;
        Result:=0;
        exit
       end;
       res:=v2/v1
      end
   end;
   push(res)
  end
 end;
  pop(res);
  Result:=res;
end;

procedure SetTime;
begin
 IntTime:=t;
end;

initialization
begin
 Oper[-1]:='sin ';
 Oper[-2]:='cos ';
 Oper[-3]:='tg ';
 Oper[-4]:='czg ';
 Oper[-5]:='exp ';
 Oper[-6]:='ln ';
 Oper[-7]:='rand ';
 Oper[-8]:='amp ';
 Oper[-9]:='rcn ';
 Oper[-10]:='ran ';
 Oper[-11]:='sqr ';
 Oper[-41]:='ifm ';
 Oper[-42]:='ifl ';
 Oper[127]:='t ';
 Oper[1]:='* ';
 Oper[2]:='/ ';
 Oper[3]:='+ ';
 Oper[4]:='- ';
 Oper[127]:='t ';
end;

end.
