unit Compose;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Generator;

type
  TComposeForm = class(TForm)
    NoteEdit: TEdit;
    OKBtn: TButton;
    CloseBtn: TButton;
    procedure CloseBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ComposeForm: TComposeForm;

implementation

{$R *.dfm}

function SearchTone(const A:Char):Single;
begin
 case A of
  'A':SearchTone:=440;
  'B':SearchTone:=660;
  'C':SearchTone:=990;
  'D':SearchTone:=1485;
  'E':SearchTone:=2228;
  'F':SearchTone:=3342;
  'G':SearchTone:=5013;
 else
   SearchTone:=0
 end;
end;


procedure TComposeForm.CloseBtnClick(Sender: TObject);
begin
 ComposeForm.Visible:=False;
end;

procedure TComposeForm.OKBtnClick(Sender: TObject);
var
 S:String;
 i,j,k,l:Integer;
 t,t0,dt:Single;
 w,c:Single;
begin
 S:=NoteEdit.Text;
 dt:=WAV.DeltaTime;
 t0:=0.5;
 c:=-2/t0;
 l:=Length(S);
 WAV.Size:=30100*l;
 for i:=1 to l do
 begin
  w:=2*pi*SearchTone(S[i]);
  t:=0;
  j:=30000*(i-1);
  for k:=1 to 30000 do
  begin
   WAV.AudioDataR[k + j]:=Sin(w*t)*exp(c*t) + Sin(2*w*t)*exp(2*c*t) + Sin(3*w*t)*exp(3*c*t);
   t:=t + dt;
  end;
  Progress(i/l);
 end;
 WAV.SetMaxLevel(30000);
 grMode:=2;
 EnableScaling;
 ShowWave(oscTime,oscTime + oscDeltaTime);
 WAV.SaveWaveFile('Data.wav');
 Info;
 ClearProgress;
 Txt('Composing done');
end;

end.
