unit Master;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ValEdit, Generator;

type
  TMasterForm = class(TForm)
    ParamEdit: TValueListEditor;
    ProcessBtn: TButton;
    ComboBox1: TComboBox;
    CloseBtn: TButton;
    procedure ProcessBtnClick(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MasterForm: TMasterForm;

implementation

{$R *.dfm}

procedure TMasterForm.ProcessBtnClick(Sender: TObject);
var
 param1,param2,param3:Single;
 param4,param5,param6:Byte;
 ErrorCode:Integer;
begin
 Case ComboBox1.ItemIndex of
  0:begin
     ProcessBtn.Caption:='Echo!';
     Val(ParamEdit.Values['Delay'],Param1,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Delay','Error !!!',0);
     Val(ParamEdit.Values['Damping'],Param2,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Damping','Error !!!',0);
     Val(ParamEdit.Values['Voices'],param4,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Voices','Error !!!',0);
     Echo(param1,param2,param4);
     ProcessBtn.Caption:='Echo done';
    end;
  1:begin
     ProcessBtn.Caption:='Filter!';
     Val(ParamEdit.Values['Frequency'],Param1,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Frequency','Error !!!',0);
     Val(ParamEdit.Values['Damping'],Param2,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Damping','Error !!!',0);
     LinearFilter(Param1,Param2);
     ProcessBtn.Caption:='Filter Done';
    end;
  2:begin
     ProcessBtn.Caption:='Noise!';
     Val(ParamEdit.Values['Intensity'],Param1,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Intensity','Error !!!',0);
     Noise(Param1);
     ProcessBtn.Caption:='Noise done';
    end;
  3:begin
     ProcessBtn.Caption:='Compression!';
     Val(ParamEdit.Values['Range'],Param1,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Range','Error !!!',0);
     Compression(Param1);
     ProcessBtn.Caption:='Compression done';
    end;
  4:begin
     ProcessBtn.Caption:='RC - Filter!';
     Val(ParamEdit.Values['Relax time'],Param1,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Relax Time','Error !!!',0);
     RC_Filter(Param1);
     ProcessBtn.Caption:='RC - Filter done';
    end;
  5:begin
     ProcessBtn.Caption:='Wall echo!';
     Val(ParamEdit.Values['Receiver distance'],Param1,ErrorCode);
     Val(ParamEdit.Values['Wall distance'],Param2,ErrorCode);
     if ErrorCode<>0 then
      Application.MessageBox('Invalid input format in Relax Time','Error !!!',0);
     WallEcho(Param1,Param2);
     ProcessBtn.Caption:='Wall echo done';
    end;
 end;
 WAV.SetMaxLevel(30000);
 WAV.SaveWaveFile('Data.wav');
 ClearProgress;
 EnableScaling;
 grMode:=2;
 ShowWave(oscTime,oscTime + oscDeltaTime);
end;

procedure TMasterForm.ComboBox1Select(Sender: TObject);
var
 i:Word;
begin
 Case ComboBox1.ItemIndex of
  0:begin
     ProcessBtn.Caption:='Echo';
     ParamEdit.Keys[1]:='Delay';
     ParamEdit.Keys[2]:='Damping';
     ParamEdit.Keys[3]:='Voices';
     for i:=4 to ParamEdit.RowCount-2 do
      ParamEdit.Keys[i]:='';
    end;
  1:begin
     ProcessBtn.Caption:='Filter';
     ParamEdit.Keys[1]:='Frequency';
     ParamEdit.Keys[2]:='Damping';
     for i:=3 to ParamEdit.RowCount-2 do
      ParamEdit.Keys[i]:='';
    end;
  2:begin
     ProcessBtn.Caption:='Noise';
     ParamEdit.Keys[1]:='Intensity';
     for i:=2 to ParamEdit.RowCount-1 do
      ParamEdit.Keys[i]:='';
    end;
  3:begin
     ProcessBtn.Caption:='Compression';
     ParamEdit.Keys[1]:='Range';
     for i:=2 to ParamEdit.RowCount-1 do
      ParamEdit.Keys[i]:='';
    end;
  4:begin
     ProcessBtn.Caption:='RC - Filter';
     ParamEdit.Keys[1]:='Relax time';
     for i:=2 to ParamEdit.RowCount-1 do
      ParamEdit.Keys[i]:='';
    end;
  5:begin
     ProcessBtn.Caption:='Wall echo';
     ParamEdit.Keys[1]:='Receiver distance';
     ParamEdit.Keys[2]:='Wall distance';
     for i:=3 to ParamEdit.RowCount-1 do
      ParamEdit.Keys[i]:='';
    end;
 end;
end;

procedure TMasterForm.CloseBtnClick(Sender: TObject);
begin
 MasterForm.Visible:=False;
end;

end.
