unit Signal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Generator;

type
  TSignalForm = class(TForm)
    SourceEdit: TComboBox;
    FreqEdit: TEdit;
    DampEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TimeEdit: TEdit;
    GenBtn: TButton;
    procedure GenBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SignalForm: TSignalForm;

implementation

{$R *.dfm}

procedure TSignalForm.GenBtnClick(Sender: TObject);
var
 Frequency, Damping:Single;
 Time:Single;
 t,dt:Single;
 w,b:Single;
 k:DWord;
 ErrorCode:Integer;
begin
 Val(TimeEdit.Text,Time,ErrorCode);
 WAV.Size:=Round(Time/WAV.DeltaTime) + 1000;
 Val(FreqEdit.Text,Frequency,ErrorCode);
 Val(DampEdit.Text,Damping,ErrorCode);
 w:=2*pi*Frequency;
 b:=-1*Damping;
 t:=0; dt:=WAV.DeltaTime;
 case SourceEdit.ItemIndex of
  0:begin
     for k:=0 to WAV.Size do
     begin
      WAV.AudioDataR[k]:=Sin(w*t)*Exp(b*t);
      t:=t + dt;
      if (k mod 1000)=0 then
       Progress(k/WAV.Size)
     end;
    end;
  1:begin
     for k:=0 to WAV.Size do
     begin
      WAV.AudioDataR[k]:=(Random(65535) - 32767)*Exp(b*t)/32767;
      t:=t + dt;
      if (k mod 1000)=0 then
       Progress(k/WAV.Size)
     end;
    end;
  2:begin
     for k:=0 to WAV.Size do
     begin
      WAV.AudioDataR[k]:=1;
      if (k mod 1000)=0 then
       Progress(k/WAV.Size)
     end
    end
 end;
 WAV.SetMaxLevel(30000);
 WAV.SaveWaveFile('Data.wav');
 grMode:=2;
 EnableScaling;
 ShowWave(oscTime,oscTime + oscDeltaTime);
 ClearProgress;
 Info;
 Txt('Data.wav saved');
 SignalForm.Visible:=False;
end;

end.
